package view;

import java.awt.Toolkit;

import javax.swing.JTextField;

public class AnswerField extends JTextField {
  private boolean beep_on_error = false;
  
  public AnswerField()
  {
    super();
    initializeForNumbers();
  }
  
  private void initializeForNumbers()
  {
    setDocument(new javax.swing.text.PlainDocument()
    {
      public void insertString(int offs, String str, javax.swing.text.AttributeSet a) throws    javax.swing.text.BadLocationException 
      {
        StringBuffer buf = new StringBuffer(str);
        int size = buf.length();
        char c;
        for (int i = 0; i < size; i++)
        {
          c = buf.charAt(i);
          
          // allow only digits
          if (!Character.isDigit(c) && c!='.')
          {
              // beep on error
              
              if (beep_on_error){
                 Toolkit.getDefaultToolkit().beep(); 
              }
                 buf.deleteCharAt(i);
          } 
        }
        super.insertString(offs, buf.toString(), a);
      }

    });
  }
  
  public void setBeepOnError(boolean beep)
  {
    beep_on_error = beep;
  }
}