package view;

import src.main.java.uk.ac.ed.ph.jacomax.JacomaxSimpleConfigurator;
import src.main.java.uk.ac.ed.ph.jacomax.MaximaConfiguration;
import src.main.java.uk.ac.ed.ph.jacomax.MaximaInteractiveProcess;
import src.main.java.uk.ac.ed.ph.jacomax.MaximaProcessLauncher;
import src.main.java.uk.ac.ed.ph.jacomax.MaximaTimeoutException;
import src.main.java.uk.ac.ed.ph.jacomax.utilities.MaximaOutputUtilities;



public class MaximaControl{
	
	final static MaximaConfiguration configuration = JacomaxSimpleConfigurator.configure();
    final static MaximaProcessLauncher launcher = new MaximaProcessLauncher(configuration);
    final static MaximaInteractiveProcess process = launcher.launchInteractiveProcess();
	
	// kontrollib, kas vrrandi pooled on vrdsed
    public static boolean AreTheyEqual(String leftSide, String rightSide) throws Exception {
        
        String maximaCommand = "is(equal(" + leftSide + "," + rightSide + "));";
        
        String result = process.executeCall(maximaCommand);
        String result2 = MaximaOutputUtilities.parseSingleLinearOutputResult(result);
        
        if(result2.equals("true")){
        	return true;
        } else{
        	return false;
        }
        
    }
    
    public static String Standardise(String expression) throws MaximaTimeoutException{
    	
    	String maximaCommand = "expand(" + expression + ");";
    	
    	String result1 = process.executeCall(maximaCommand);
        String result = MaximaOutputUtilities.parseLinearResult(result1);
        
        int lineOpening1 = result.indexOf('(');
        int lineOpeningEnd1 = result.indexOf(')');
    	int lineOpening2 = result.lastIndexOf('(');
    	result = result.substring(0,lineOpening1) + addSpaces(lineOpening1, lineOpeningEnd1) + 
    			result.substring(lineOpeningEnd1+1, lineOpening2);
    	
    	return result;
    	
    }
    
    public static String addSpaces(int lineOpening1, int lineOpeningEnd1){
    	int numberOfSpaces = lineOpeningEnd1 - lineOpening1 + 1;
    	String spaces = "";
    	for(int i = 0; i < numberOfSpaces; i++){
    		spaces += " ";
    	}
    	return spaces;
    }

}
