package view;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Enumeration;
import java.util.HashSet;
import java.util.Hashtable;

import src.main.java.uk.ac.ed.ph.jacomax.MaximaTimeoutException;

public class Point {
	public String expression;
	public String expressionStd;
	public ArrayList<String> usedExpressions;
	public ArrayList<String> usedExpressionsStd;
	public static ArrayList<Point> foundPoints = new ArrayList<Point>();
	public static ArrayList<String> foundValues = new ArrayList<String>();
	public static int index;
	public static String finalAnswer;
	public static String finalAnswerStd;
	public static ArrayList<String> operators;
	public static ArrayList<String> variables;

	public Point(String expression, ArrayList<String> usedExpressions,
			String expressionStd, ArrayList<String> usedExpressionsStd) {
		this.expression = expression;
		this.usedExpressions = usedExpressions;
		this.expressionStd = expressionStd;
		this.usedExpressionsStd = usedExpressionsStd;
	}

	public static ArrayList<String> FindSolution(
			Hashtable<String, String> seosedKysAval, String lppvastus,
			ArrayList<String> jubaArvutatud) throws Exception {

		// avaldised, millele on vastavusse mratud ksimused (e. sisukad)
		ArrayList<String> meaningfulExpressions = new ArrayList<String>();
		for (String expression : seosedKysAval.values()) {
			if (expression.length() != 1) {
				meaningfulExpressions.add(expression);
			}
		}
		ArrayList<String> meaningfulExpressionsStd = new ArrayList<String>();
		for (String expression : meaningfulExpressions) {
			meaningfulExpressionsStd.add(MaximaControl.Standardise(expression));
		}

		finalAnswer = lppvastus.replaceAll(":", "/");
		finalAnswerStd = MaximaControl.Standardise(finalAnswer);

		variables = FindVariables(lppvastus);
		index = variables.size();
		operators = FindOperators(lppvastus);

		for (String expression : jubaArvutatud) {
			if (expression.length() != 1) {
				expression = "(" + expression.replaceAll(":", "/") + ")";
			}
			String expressionStd = MaximaControl.Standardise(expression);
			Point point = new Point(expression, null, expressionStd, null);
			foundPoints.add(point);
			foundValues.add(expression);
		}

		ArrayList<Point> currentLevel = FindFirstLevel(meaningfulExpressionsStd);
		while (FinalPointInLevel(currentLevel).isEmpty()) {
			if (!currentLevel.isEmpty()) {
				ArrayList<Point> newLevel = FindNextLevel(meaningfulExpressionsStd);
				currentLevel.clear();
				currentLevel.addAll(newLevel);
			} else {
				System.out.println("ei ole lahenduv!");
				return null;
			}
		}

		foundPoints.clear();
		foundValues.clear();

		return FindFinalPointInLevel(FinalPointInLevel(currentLevel))
				.getUsedExpressions();
	}

	public static ArrayList<Point> FindFirstLevel(
			ArrayList<String> meaningfulExpressionsStd)
			throws MaximaTimeoutException {
		ArrayList<Point> firstLevel = new ArrayList<Point>();
		for (String operator : operators) {
			if (operator.equals("+") || operator.equals("*")) {
				int index = 0;
				for (String value : foundValues) {
					for (int i = index; i < foundValues.size(); i++) {
						Point point = CreatePoint(i, value, foundValues.get(i),
								operator, meaningfulExpressionsStd);
						if (point != null) {
							firstLevel.add(point);
						}

					}
					index++;
				}

			} else {
				for (String value : foundValues) {
					for (int i = 0; i < foundValues.size(); i++) {
						Point point = CreatePoint(i, value, foundValues.get(i),
								operator, meaningfulExpressionsStd);
						if (point != null) {
							firstLevel.add(point);
						}
					}
				}
			}

		}
		for (Point point : firstLevel) {
			foundPoints.add(point);
			foundValues.add(point.getExpression());
		}
		return firstLevel;
	}

	public static ArrayList<Point> FindNextLevel(
			ArrayList<String> meaningfulExpressionsStd)
			throws MaximaTimeoutException {
		ArrayList<Point> nextLevel = new ArrayList<Point>();
		for (String operator : operators) {
			if (operator.equals("+") || operator.equals("*")) {
				int indeks = 0;
				int newindeks = 0;
				for (String value : foundValues) {
					if (indeks <= index) {
						newindeks = index;
					} else {
						newindeks = indeks;
					}
					for (int i = newindeks; i < foundValues.size(); i++) {
						Point point = CreatePoint(i, value, foundValues.get(i),
								operator, meaningfulExpressionsStd);
						if (point != null) {
							nextLevel.add(point);
						}
					}
					indeks++;
				}
			} else {
				for (String value : foundValues) {
					for (int i = index; i < foundValues.size(); i++) {
						Point point = CreatePoint(i, value, foundValues.get(i),
								operator, meaningfulExpressionsStd);
						if (point != null) {
							nextLevel.add(point);
						}
						if (foundValues.indexOf(value) < index) {
							Point point2 = CreatePoint(i, foundValues.get(i),
									value, operator, meaningfulExpressionsStd);
							if (point2 != null) {
								nextLevel.add(point2);
							}
						}
					}
				}
			}
		}
		index = foundValues.size();
		for (Point point : nextLevel) {
			foundPoints.add(point);
			foundValues.add(point.getExpression());
		}
		return nextLevel;
	}

	public static Point CreatePoint(int i, String value1, String value2,
			String operator, ArrayList<String> meaningfulExpressionsStd)
			throws MaximaTimeoutException {
		String expression = "(" + value1 + operator + value2 + ")";
		String expressionStd = MaximaControl.Standardise(expression);
		if (meaningfulExpressionsStd.contains(expressionStd)) {
			Point parent1 = foundPoints.get(foundValues.indexOf(value1));
			Point parent2 = foundPoints.get(foundValues.indexOf(value2));

			ArrayList<String> usedExpressions = new ArrayList<String>();
			ArrayList<String> usedExpressionsStd = new ArrayList<String>();

			ArrayList<String> p1usedExpressions = parent1.getUsedExpressions();
			ArrayList<String> p2usedExpressions = parent2.getUsedExpressions();
			ArrayList<String> p1usedExpressionsStd = parent1
					.getUsedExpressionsStd();
			ArrayList<String> p2usedExpressionsStd = parent2
					.getUsedExpressionsStd();

			int p1size;
			if (p1usedExpressions == null) {
				p1size = 0;
			} else {
				p1size = p1usedExpressions.size();
			}

			int p2size;
			if (p2usedExpressions == null) {
				p2size = 0;
			} else {
				p2size = p2usedExpressions.size();
			}
			int size;
			if (p1size < p2size) {
				size = p2size;
			} else {
				size = p1size;
			}
			for (int j = 0; j < size; j++) {
				if (j < p1size) {
					if (!usedExpressionsStd.contains(p1usedExpressionsStd
							.get(j))) {
						usedExpressions.add(p1usedExpressions.get(j));
						usedExpressionsStd.add(p1usedExpressionsStd.get(j));
					}
				}
				if (j < p2size) {
					if (!usedExpressionsStd.contains(p2usedExpressionsStd
							.get(j))) {
						usedExpressions.add(p2usedExpressions.get(j));
						usedExpressionsStd.add(p2usedExpressionsStd.get(j));
					}
				}
			}

			usedExpressions.add(expression);
			usedExpressionsStd.add(expressionStd);

			Point point = new Point(expression, usedExpressions, expressionStd,
					usedExpressionsStd);
			return point;
		}
		return null;
	}

	public static ArrayList<Point> FinalPointInLevel(
			ArrayList<Point> currentPoints) throws Exception {
		ArrayList<Point> finalPoints = new ArrayList<Point>();
		if (!currentPoints.isEmpty() && currentPoints != null) {
			for (Point point : currentPoints) {
				if (MaximaControl.AreTheyEqual(point.getExpression(),
						finalAnswer)) {
					finalPoints.add(point);
					// return point;
				}
			}
		}
		return finalPoints;
	}

	public static Point FindFinalPointInLevel(ArrayList<Point> finalLevel) {
		int shortestRoadLength = 100;
		Point finalPoint = null;
		for (Point point : finalLevel) {
			int pointRoadLength = point.getUsedExpressions().size();
			if (pointRoadLength < shortestRoadLength) {
				shortestRoadLength = pointRoadLength;
				finalPoint = point;
			}
		}

		return finalPoint;
	}

	public static String GiveHint(ArrayList<String> solution,
			Hashtable<String, String> relations, ArrayList<String> foundValues)
			throws Exception {

		// leiab lpplahenduse leidmiseks veel tegemata sammud
		ArrayList<String> foundValuesStd = new ArrayList<String>();

		for (String value : foundValues) {
			foundValuesStd.add(MaximaControl.Standardise(value.replaceAll(":",
					"/")));
		}
		ArrayList<String> possibleHints = new ArrayList<String>();
		for (String value : solution) {
			if (value.length() > 1) {
				String valueStd = MaximaControl.Standardise(value);
				if (!foundValuesStd.contains(valueStd)) {
					possibleHints.add(value);
				}
			}
		}
		String hint = possibleHints.get(0);

		// leiab vihje avaldisele vastava ksimuse
		Enumeration<String> expressions = relations.keys();
		while (expressions.hasMoreElements()) {
			String expression = expressions.nextElement();
			if (MaximaControl.AreTheyEqual(hint, expression)) {
				return relations.get(expression);
			}
		}
		return null;

	}

	public String getExpression() {
		return expression;
	}

	public ArrayList<String> getUsedExpressions() {
		return usedExpressions;
	}

	public ArrayList<String> getUsedExpressionsStd() {
		return usedExpressionsStd;
	}

	// kiki muutujaid ei pruugi olla kasutatud lppvastuse saamiseks
	public static ArrayList<String> FindVariables(String lppvastus) {
		ArrayList<String> muutujad = new ArrayList<String>();

		for (char tht : lppvastus.toCharArray()) {
			if (!(tht == '(' || tht == ')' || tht == '+' || tht == '*'
					|| tht == '/' || tht == '-')) {
				muutujad.add(Character.toString(tht));
			}
		}
		// eemalda kordused
		HashSet<String> kordusteta = new HashSet<String>();
		kordusteta.addAll(muutujad);
		muutujad.clear();
		muutujad.addAll(kordusteta);
		Collections.sort(muutujad);

		return muutujad;
	}

	// milliseid tehteid lppvastuse saamiseks on vaja
	public static ArrayList<String> FindOperators(String lppvastus) {
		ArrayList<String> tehted = new ArrayList<String>();
		if (lppvastus.contains("+")) {
			tehted.add("+");
		}
		if (lppvastus.contains("-")) {
			tehted.add("-");
		}
		if (lppvastus.contains("*")) {
			tehted.add("*");
		}
		if (lppvastus.contains("/")) {
			tehted.add("/");
		}
		return tehted;
	}

	@Override
	public String toString() {
		return expression + " " + usedExpressions;
	}
}