package creator;

import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.math.RoundingMode;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.text.NumberFormat;
import java.util.Random;

import javax.swing.ButtonGroup;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextArea;
import javax.swing.JTextField;

/**
 * 
 * Paneel uue muutuja lisamiseks
 *
 */

public class AddVariablePanel {

	private JTextArea textArea;
	private JPanel chooseVariablePanel;
	private JRadioButton integerButton;
	private JRadioButton fractionButton;
	private JRadioButton rangeButton;
	private JRadioButton numberButton;
	private JTextField rangeStart = new JTextField(4);
	private JTextField rangeEnd = new JTextField(4);
	private JTextField singleValue = new JTextField(4);
	private int variableCounter;
	private TextPanel textPanel;

	// paneeli loomine
	public AddVariablePanel(TextPanel textPanel, int variableCounter2, int pos) {
		this.textPanel = textPanel;
		this.textArea = textPanel.getTextArea();
		this.variableCounter = variableCounter2;
		chooseVariablePanel = new JPanel(new GridLayout(0, 4));
		addButtons(chooseVariablePanel);
		int selection = JOptionPane.showOptionDialog(null, chooseVariablePanel, "Muutuja lisamine",
				JOptionPane.OK_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE, null, new String[] { "OK", "Katkesta" },
				"default");
		// If user clicked OK, add variable to textArea
		if (selection == 0) {
			addVariable(pos);
		}
	}

	// Muutuja lisamine
	//TODO: refactoring
	private void addVariable(int pos) {
		String value;
		Random rand = new Random();
		DecimalFormat decimalFormat;
		String errorMessage;
		int decimal;

		NumberFormat format = new DecimalFormat();
		// Formatting from:
		// http://stackoverflow.com/questions/16309189/java-use-decimalformat-to-format-doubles-and-integers-but-keep-integers-without
		format.setRoundingMode(RoundingMode.FLOOR);
		DecimalFormatSymbols custom = new DecimalFormatSymbols();
		custom.setDecimalSeparator('.');
		((DecimalFormat) format).setDecimalFormatSymbols(custom);
		if (integerButton.isSelected()) {
			errorMessage = "Palun sisesta tisarv.";
			decimal = 0;
			format.setMaximumFractionDigits(0);
		} else {
			format.setMinimumFractionDigits(1);
			errorMessage = "Palun kasuta kmnendmurru tisosa eraldamiseks punkti.";
			decimal = 1;
		}
		if (singleValue.isEditable()) {
			try {
				value = format.format(Float.parseFloat(singleValue.getText()));
				char variableName = generateVariableName();
				textArea.insert(" #" + variableName + "=" + value + " ", pos);
			} catch (NumberFormatException e) {
				JOptionPane.showMessageDialog(chooseVariablePanel, "Ei sisestatud korrektset arvu! " + errorMessage);
			}
		} else {
			try {
				if (decimal == 0) {
					int start = Integer.parseInt(rangeStart.getText());
					int end = Integer.parseInt(rangeEnd.getText());
					int randomValue;
					if (end >= start){
						randomValue = rand.nextInt((int) (end-start)) + start;
					} else {
						randomValue = rand.nextInt((int) (start-end)) + end;
					}
					value = Integer.toString(randomValue);
					char variableName = generateVariableName();
					textPanel.getRangeVariables().add("#" + variableName + ":" + start + ":" + end + ":" + decimal); // TODO: lahendaja vahemikud
					textArea.insert(" #" + variableName + "=" + value + " ", pos);
				} else {
					float start = Float.parseFloat(rangeStart.getText());
					float end = Float.parseFloat(rangeEnd.getText());
					float randomValue;
					int numberOfDigits = 0;
					System.out.println(rangeStart.getText());
					if (rangeStart.getText().contains(".")){
						numberOfDigits = rangeStart.getText().substring(rangeStart.getText().indexOf(".")+1).length();
						System.out.println(numberOfDigits);
					}
					if (rangeEnd.getText().contains(".")){
						int otherDigits = rangeEnd.getText().substring(rangeEnd.getText().indexOf(".")+1).length();
						if (otherDigits > numberOfDigits){
							numberOfDigits = otherDigits;
						}
					}
					if (numberOfDigits > 0){
						format.setMaximumFractionDigits(numberOfDigits);	
					}
					else{
						format.setMaximumFractionDigits(1);	
					}
					randomValue = rand.nextFloat() * (end - start) + start;
					value = format.format(randomValue);
					char variableName = generateVariableName();
					textPanel.getRangeVariables().add("#" + variableName + ":" + start + ":" + end + ":" + decimal); // TODO: lahendaja vahemikud
					textArea.insert(" #" + variableName + "=" + value + " ", pos);
				}
				
				
			} catch (NumberFormatException e) {
				JOptionPane.showMessageDialog(chooseVariablePanel, "Ei sisestatud ligu otspunkte. " + errorMessage);
			}
		}

	}

	private char generateVariableName() {
		String variableCharacters = "abcdefghijklmnopqrstuvxy";
		return variableCharacters.charAt(variableCounter % variableCharacters.length());
	}

	private void addButtons(JPanel chooseVariablePanel) {
		ButtonGroup group1 = new ButtonGroup();
		ButtonGroup group2 = new ButtonGroup();

		integerButton = new JRadioButton("tisarv");
		fractionButton = new JRadioButton("kmnendmurd");
		rangeButton = new JRadioButton("ligust");
		numberButton = new JRadioButton("arv");

		group1.add(integerButton);
		group1.add(fractionButton);
		group2.add(numberButton);
		group2.add(rangeButton);

		addListeners();
		addComponents();

		numberButton.setSelected(true);
		integerButton.setSelected(true);
		rangeStart.setEditable(false);
		rangeEnd.setEditable(false);
	}

	private void addComponents() {
		chooseVariablePanel.add(integerButton);
		chooseVariablePanel.add(numberButton);
		chooseVariablePanel.add(singleValue);
		chooseVariablePanel.add(new JLabel());
		chooseVariablePanel.add(fractionButton);
		chooseVariablePanel.add(rangeButton);
		chooseVariablePanel.add(rangeStart);
		chooseVariablePanel.add(rangeEnd);
	}

	private void addListeners() {

		numberButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				rangeStart.setText("");
				rangeEnd.setText("");
				rangeStart.setEditable(false);
				rangeEnd.setEditable(false);
				singleValue.setEditable(true);
			}
		});

		rangeButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				singleValue.setText("");
				rangeStart.setEditable(true);
				rangeEnd.setEditable(true);
				singleValue.setEditable(false);
			}
		});

		integerButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
			}
		});

		fractionButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
			}
		});

	}

}
