package creator;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.Random;

import javax.swing.ButtonGroup;
import javax.swing.GroupLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.LayoutStyle.ComponentPlacement;

/**
 * lesande teksti sisestamise paneel
 */

public class TextPanel extends JPanel {

	private JTextArea textArea;
	private JButton addVariableButton;
	private int variableCounter = 0;
	private ArrayList<String> rangeVariables = new ArrayList<String>();

	TextPanel() {
		setMinimumSize(new Dimension(800, 100));
		setMaximumSize(new Dimension(1600, 200));
		this.setLayout(new BorderLayout());
		textArea = new JTextArea(7, 50);
		JScrollPane scrollPane = new JScrollPane(textArea);
		add(new JLabel("Sisesta lesande tekst:", JLabel.CENTER), BorderLayout.NORTH);
		add(scrollPane);
		addButton();
	}

	private void addButton() {
		addVariableButton = new JButton("Lisa muutuja");
		addVariableButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				addVariableActionPerformed(evt);
			}
		});
		add(addVariableButton, BorderLayout.EAST);
	}
	
	// Muutuja lisamise hpikaken
	private void addVariableActionPerformed(ActionEvent evt) {
		int pos = textArea.getCaretPosition();
		int before = textArea.getText().length();
		new AddVariablePanel(this, variableCounter, pos);
		if (textArea.getText().length() > before) {
			variableCounter += 1;
			textArea.setCaretPosition(pos + textArea.getText().length() - before);
		}
		textArea.requestFocus();
	}

	public JTextArea getTextArea() {
		return textArea;
	}
	
	public void setText(String t){
		textArea.setText(t);
	}
	

	public ArrayList<String> getRangeVariables() {
		return rangeVariables;
	}

	public void setRangeVariables(ArrayList<String> rangeVariables) {
		this.rangeVariables = rangeVariables;
	}

	public int getVariableCounter() {
		return variableCounter;
	}

	public void setVariableCounter(int variableCounter) {
		this.variableCounter = variableCounter;
	}
	
}
